function Create(self)
	self.LTimer = Timer();
	self.firemode = 0; -- 0 is inactive, 1 is gravitate, 2 is launch, 3 is drop. This is NOT to be edited.
	self.launchsound = false;
	self.canlaunchsound = true;
	self.candropsound = true;
	self.totractorbeam = true;

--------------------
----- The variables here can be changed to alter various properties of the phys cannon.

	self.cantractorbeam = true; -- allows the phys cannon to pull objects at a distance if holding nothing. true for yes, false for no.
	self.cangrabMOSRandAE = true; -- allows the phys cannon to grab and throw MOSRotatings and Emitters. true for yes, false for no.
	self.canparalize = true; -- allows the phys cannon to paralize actors that it's holding. true for yes, false for no.
	self.launchpower = 320; -- strength of the launch. 120 is default.
	self.pickuppower = 320; -- strength of the pull. 120 is default.
	self.launchrange = 35; -- size of the area to check for objects to launch. 35 is default.
	self.pickuprange = 35; -- size of the area to check for objects to pull. 35 is default.

--------------------

   local curdist = 50;
      for actor in MovableMan.Actors do
         local avgx = actor.Pos.X - self.Pos.X;
         local avgy = actor.Pos.Y - self.Pos.Y;
         local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
         if dist < curdist and actor:HasObject("Mech Gravi Gun") then
	self.parent = actor;
	end
    end
end

function Update(self)
   if self.firemode == 0 and self.LTimer:IsPastSimMS(5) then
	self.firemode = 1;
	end

   if self.firemode == 1 and MovableMan:IsActor(self.parent) then
      for actor in MovableMan.Actors do
         local avgx = actor.Pos.X - self.Pos.X;
         local avgy = actor.Pos.Y - self.Pos.Y;
         local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
         if dist < self.pickuprange and actor.ID ~= self.parent.ID then
	actor.Vel = Vector((self.Pos.X - actor.Pos.X), (self.Pos.Y - actor.Pos.Y)) / (1 + (actor.Mass / self.pickuppower));
	actor:SetWhichMOToNotHit(self.parent,0.3);
	self.totractorbeam = false;
    if self.canparalize == true then
	actor:SetControllerMode(Controller.CIM_DISABLED, -1);
	end
    end
end
end

   if self.firemode == 1 and MovableMan:IsActor(self.parent) then
      for item in MovableMan.Items do
         local itemavgx = item.Pos.X - self.Pos.X;
         local itemavgy = item.Pos.Y - self.Pos.Y;
         local itemdist = math.sqrt(itemavgx ^ 2 + itemavgy ^ 2);
         if itemdist < self.pickuprange then
	item.Vel = Vector((self.Pos.X - item.Pos.X), (self.Pos.Y - item.Pos.Y)) / (1 + (item.Mass / self.pickuppower));
	item:SetWhichMOToNotHit(self.parent,0.3);
	self.totractorbeam = false;
	end
    end
end

   if self.firemode == 1 and MovableMan:IsActor(self.parent) and self.cangrabMOSRandAE == true then
      for particle in MovableMan.Particles do
	if particle.ClassName == "MOSRotating" or particle.ClassName == "AEmitter" then
         local paravgx = particle.Pos.X - self.Pos.X;
         local paravgy = particle.Pos.Y - self.Pos.Y;
         local dist = math.sqrt(paravgx ^ 2 + paravgy ^ 2);
         if dist < self.pickuprange then
	particle.Vel = Vector((self.Pos.X - particle.Pos.X), (self.Pos.Y - particle.Pos.Y)) / (1 + (particle.Mass / self.pickuppower));
	particle:SetWhichMOToNotHit(self.parent,0.3);
	self.totractorbeam = false;
	end
    end
end
end

   if self.totractorbeam == true and self.cantractorbeam == true and self.LTimer:IsPastSimMS(15) then
	self.tractor = CreateMOPixel("Particle Mech Gravi Gun Tractor Beam","D9.rte");
	self.tractor.Pos = self.Pos;
	MovableMan:AddParticle(self.tractor);
	self.tractor.Vel = self.Vel;
	self.totractorbeam = false;
	end

   if MovableMan:IsActor(self.parent) then
    if not (self.parent:GetController():IsState(Controller.WEAPON_FIRE)) and not (self.parent:GetController():IsState(Controller.PIE_MENU_ACTIVE)) then
	self.firemode = 2;
	end
    end

   if MovableMan:IsActor(self.parent) then
    if not (self.parent:GetController():IsState(Controller.WEAPON_FIRE)) and self.parent:GetController():IsState(Controller.PIE_MENU_ACTIVE) and self.candropsound == true then
	self.firemode = 3;
	local dropsound = CreateAEmitter("Mech Gravi Gun Sound Drop","D9.rte");
	dropsound.Pos = self.parent.Pos;
	MovableMan:AddParticle(dropsound);
	self.candropsound = false;
    if self.canparalize == true then
      for actor in MovableMan.Actors do
         local avgx = actor.Pos.X - self.Pos.X;
         local avgy = actor.Pos.Y - self.Pos.Y;
         local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
         if dist < self.pickuprange and actor.ID ~= self.parent.ID then
	actor:SetControllerMode(Controller.CIM_AI, -1);
	end
    end
end
end
end

   if self.firemode == 2 and MovableMan:IsActor(self.parent) then
      for actor in MovableMan.Actors do
         local avgx = actor.Pos.X - self.Pos.X;
         local avgy = actor.Pos.Y - self.Pos.Y;
         local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
         if dist < self.launchrange and actor.ID ~= self.parent.ID then
	actor.Vel = self.Vel / (1 + (actor.Mass / self.launchpower));
	self.launchsound = true;
    if self.canparalize == true then
	actor:SetControllerMode(Controller.CIM_AI, -1);
	end
    end
end
end

   if self.firemode == 2 and MovableMan:IsActor(self.parent) then
      for item in MovableMan.Items do
         local itemavgx = item.Pos.X - self.Pos.X;
         local itemavgy = item.Pos.Y - self.Pos.Y;
         local itemdist = math.sqrt(itemavgx ^ 2 + itemavgy ^ 2);
         if itemdist < self.launchrange then
	item.Vel = self.Vel / (1 + (item.Mass / self.launchpower));
	self.launchsound = true;
	end
    end
end

   if self.firemode == 2 and MovableMan:IsActor(self.parent) and self.cangrabMOSRandAE == true then
      for particle in MovableMan.Particles do
	if particle.ClassName == "MOSRotating" or particle.ClassName == "AEmitter" then
         local paravgx = particle.Pos.X - self.Pos.X;
         local paravgy = particle.Pos.Y - self.Pos.Y;
         local dist = math.sqrt(paravgx ^ 2 + paravgy ^ 2);
         if dist < self.launchrange then
	particle.Vel = self.Vel / (1 + (particle.Mass / self.launchpower));
	self.launchsound = true;
	end
    end
end
end

   if self.launchsound == true and self.canlaunchsound == true then
	local firesound = CreateAEmitter("Mech Gravi Gun Sound Fire","D9.rte");
	firesound.Pos = self.parent.Pos;
	MovableMan:AddParticle(firesound);
	self.launchsound = false;
	self.canlaunchsound = false;
	end

end